-------------------------------------------------------------------------------
--! @file       Feistel_A.vhd
--! @author     William Diehl
--! @brief      SCREAM Feistel_A
--! @date       29 July 2016
-------------------------------------------------------------------------------


LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity Feistel_A is
	port(

         t0: in std_logic_vector(15 downto 0);
         x1: in std_logic_vector(15 downto 0);
         x2: in std_logic_vector(15 downto 0);
         x3: in std_logic_vector(15 downto 0);
         x4: in std_logic_vector(15 downto 0);
         x5: in std_logic_vector(15 downto 0);
         x6: in std_logic_vector(15 downto 0);
         x7: in std_logic_vector(15 downto 0);

	      w4: out std_logic_vector(15 downto 0);
         w5: out std_logic_vector(15 downto 0);
    	   w6: out std_logic_vector(15 downto 0);
         w7: out std_logic_vector(15 downto 0)
         );
	 
end Feistel_A;

architecture dataflow of Feistel_A is

SIGNAL	t1:	STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	t2:	STD_LOGIC_VECTOR(15 DOWNTO 0);

begin

t1 <= x1 xor x3;
t2 <= x2 xor t0;
w4 <= x4 xor ((x3 xor t2) and (x2 xor t1));
w5 <= x5 xor t2;
w6 <= x6 xor (x3 and t0);
w7 <= x7 xor (t1 and t2);

end dataflow;

