-------------------------------------------------------------------------------
--! @file       Inv_LBox_2.vhd
--! @author     William Diehl
--! @brief      SCREAM Inv_LBox_2
--! @date       29 July 2016
-------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY Inv_LBox_2 IS

	PORT(
		Addr: IN STD_LOGIC_VECTOR(7 DOWNTO 0);
		Dout: OUT STD_LOGIC_VECTOR(15 DOWNTO 0)
	);

END Inv_LBox_2;

ARCHITECTURE dataflow OF Inv_LBox_2 IS

SIGNAL index: INTEGER RANGE 0 TO 255;
TYPE vector_array IS ARRAY (0 to 255) OF STD_LOGIC_VECTOR(15 DOWNTO 0);
CONSTANT memory : vector_array := 
	(


	x"0000", x"1e54", x"b9be", x"a7ea", x"19d8", x"078c", x"a066", x"be32",
	x"a8a5", x"b6f1", x"111b", x"0f4f", x"b17d", x"af29", x"08c3", x"1697",
	x"6abf", x"74eb", x"d301", x"cd55", x"7367", x"6d33", x"cad9", x"d48d",
	x"c21a", x"dc4e", x"7ba4", x"65f0", x"dbc2", x"c596", x"627c", x"7c28",
	x"7ee5", x"60b1", x"c75b", x"d90f", x"673d", x"7969", x"de83", x"c0d7",
	x"d640", x"c814", x"6ffe", x"71aa", x"cf98", x"d1cc", x"7626", x"6872",
	x"145a", x"0a0e", x"ade4", x"b3b0", x"0d82", x"13d6", x"b43c", x"aa68",
	x"bcff", x"a2ab", x"0541", x"1b15", x"a527", x"bb73", x"1c99", x"02cd",
	x"7bd6", x"6582", x"c268", x"dc3c", x"620e", x"7c5a", x"dbb0", x"c5e4",
	x"d373", x"cd27", x"6acd", x"7499", x"caab", x"d4ff", x"7315", x"6d41",
	x"1169", x"0f3d", x"a8d7", x"b683", x"08b1", x"16e5", x"b10f", x"af5b",
	x"b9cc", x"a798", x"0072", x"1e26", x"a014", x"be40", x"19aa", x"07fe",
	x"0533", x"1b67", x"bc8d", x"a2d9", x"1ceb", x"02bf", x"a555", x"bb01",
	x"ad96", x"b3c2", x"1428", x"0a7c", x"b44e", x"aa1a", x"0df0", x"13a4",
	x"6f8c", x"71d8", x"d632", x"c866", x"7654", x"6800", x"cfea", x"d1be",
	x"c729", x"d97d", x"7e97", x"60c3", x"def1", x"c0a5", x"674f", x"791b",
	x"86d8", x"988c", x"3f66", x"2132", x"9f00", x"8154", x"26be", x"38ea",
	x"2e7d", x"3029", x"97c3", x"8997", x"37a5", x"29f1", x"8e1b", x"904f",
	x"ec67", x"f233", x"55d9", x"4b8d", x"f5bf", x"ebeb", x"4c01", x"5255",
	x"44c2", x"5a96", x"fd7c", x"e328", x"5d1a", x"434e", x"e4a4", x"faf0",
	x"f83d", x"e669", x"4183", x"5fd7", x"e1e5", x"ffb1", x"585b", x"460f",
	x"5098", x"4ecc", x"e926", x"f772", x"4940", x"5714", x"f0fe", x"eeaa",
	x"9282", x"8cd6", x"2b3c", x"3568", x"8b5a", x"950e", x"32e4", x"2cb0",
	x"3a27", x"2473", x"8399", x"9dcd", x"23ff", x"3dab", x"9a41", x"8415",
	x"fd0e", x"e35a", x"44b0", x"5ae4", x"e4d6", x"fa82", x"5d68", x"433c",
	x"55ab", x"4bff", x"ec15", x"f241", x"4c73", x"5227", x"f5cd", x"eb99",
	x"97b1", x"89e5", x"2e0f", x"305b", x"8e69", x"903d", x"37d7", x"2983",
	x"3f14", x"2140", x"86aa", x"98fe", x"26cc", x"3898", x"9f72", x"8126",
	x"83eb", x"9dbf", x"3a55", x"2401", x"9a33", x"8467", x"238d", x"3dd9",
	x"2b4e", x"351a", x"92f0", x"8ca4", x"3296", x"2cc2", x"8b28", x"957c",
	x"e954", x"f700", x"50ea", x"4ebe", x"f08c", x"eed8", x"4932", x"5766",
	x"41f1", x"5fa5", x"f84f", x"e61b", x"5829", x"467d", x"e197", x"ffc3"



);

BEGIN

	index <= to_integer(unsigned(Addr));
	Dout <= memory(index);

END dataflow;