-------------------------------------------------------------------------------
--! @file       RC_LUT.vhd
--! @author     William Diehl
--! @brief      SCREAM RC_LUT
--! @date       29 July 2016
-------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY RC_LUT IS

	PORT(
		sigma: in std_logic_vector(3 downto 0);
		rho : in std_logic;
		rc: out std_logic_vector(15 downto 0)
	);

END RC_LUT;

ARCHITECTURE dataflow OF RC_LUT IS

SIGNAL index: INTEGER RANGE 0 TO 31;
TYPE vector_array IS ARRAY (0 to 31) OF STD_LOGIC_VECTOR(15 DOWNTO 0);
CONSTANT memory : vector_array := 
	(

-- rho = 0

	x"0000", x"112e", x"225c", x"338a", x"44b8", x"55e6",
	x"6714", x"7842", x"8970", x"9a9e", x"abcc", x"bcfa",
   x"0000", x"0000", x"0000", x"0000",
	
-- rho = 1

   x"0897", x"19c5", x"2af3", x"3c21", x"4d4f", x"5e7d",
   x"6fab", x"80d9", x"9207", x"a335", x"b463", x"c591",
	x"0000", x"0000", x"0000", x"0000"           
	
);

BEGIN

	index <= to_integer(unsigned(rho & sigma));
	rc <= memory(index);

END dataflow;




